apeman-api-recover
==========

<!---
This file is generated by ape-tmpl. Do not update manually.
--->

<!-- Badge Start -->
<a name="badges"></a>

[![Build Status][bd_travis_shield_url]][bd_travis_url]
[![Code Climate][bd_codeclimate_shield_url]][bd_codeclimate_url]
[![Code Coverage][bd_codeclimate_coverage_shield_url]][bd_codeclimate_url]
[![npm Version][bd_npm_shield_url]][bd_npm_url]
[![JS Standard][bd_standard_shield_url]][bd_standard_url]

[bd_repo_url]: https://github.com/apeman-api-labo/apeman-api-recover
[bd_travis_url]: http://travis-ci.org/apeman-api-labo/apeman-api-recover
[bd_travis_shield_url]: http://img.shields.io/travis/apeman-api-labo/apeman-api-recover.svg?style=flat
[bd_travis_com_url]: http://travis-ci.com/apeman-api-labo/apeman-api-recover
[bd_travis_com_shield_url]: https://api.travis-ci.com/apeman-api-labo/apeman-api-recover.svg?token=
[bd_license_url]: https://github.com/apeman-api-labo/apeman-api-recover/blob/master/LICENSE
[bd_codeclimate_url]: http://codeclimate.com/github/apeman-api-labo/apeman-api-recover
[bd_codeclimate_shield_url]: http://img.shields.io/codeclimate/github/apeman-api-labo/apeman-api-recover.svg?style=flat
[bd_codeclimate_coverage_shield_url]: http://img.shields.io/codeclimate/coverage/github/apeman-api-labo/apeman-api-recover.svg?style=flat
[bd_gemnasium_url]: https://gemnasium.com/apeman-api-labo/apeman-api-recover
[bd_gemnasium_shield_url]: https://gemnasium.com/apeman-api-labo/apeman-api-recover.svg
[bd_npm_url]: http://www.npmjs.org/package/apeman-api-recover
[bd_npm_shield_url]: http://img.shields.io/npm/v/apeman-api-recover.svg?style=flat
[bd_standard_url]: http://standardjs.com/
[bd_standard_shield_url]: https://img.shields.io/badge/code%20style-standard-brightgreen.svg

<!-- Badge End -->


<!-- Description Start -->
<a name="description"></a>

Recover API for apeman

<!-- Description End -->


<!-- Overview Start -->
<a name="overview"></a>



<!-- Overview End -->


<!-- Sections Start -->
<a name="sections"></a>

<!-- Section from "doc/guides/01.Installation.md.hbs" Start -->

<a name="section-doc-guides-01-installation-md"></a>

Installation
-----

```bash
$ npm install apeman-api-recover --save
```


<!-- Section from "doc/guides/01.Installation.md.hbs" End -->

<!-- Section from "doc/guides/02.Usage.md.hbs" Start -->

<a name="section-doc-guides-02-usage-md"></a>

Usage
---------

Define a module in Apemanfile and run the server.

```javascript
/** Example of Apemanfile.js */

'use strict'

const co = require('co')

let { NODE_ENV } = process.env
let { User, UserSign, UserRecover } = require('./example-models')

module.exports = {
  $cwd: __dirname,
  $pkg: { /* ... */ },
  $proto: [ /* ... */ ],
  $api: {
    // Define APIs
    'module01': require('apeman-api-recover')(
      User, UserSign, UserRecover,
      {
        logging: NODE_ENV === 'development'
      }
    )
  }
}

```

Then, call the module from client script

```javascript
#!/usr/bin/env node

/**
 * Example client
 */
'use strict'

const co = require('co')
const apemanApiClient = require('apeman-api-client')

co(function * () {
  // Setup an client
  let api = yield apemanApiClient('/api')

  // Connect to a module
  let recover = yield api.connect('module01')
  let pong = yield recover.ping()
  /* ... */

  yield recover.issue('hoge@example.com')
})


```


<!-- Section from "doc/guides/02.Usage.md.hbs" End -->

<!-- Section from "doc/guides/03.Methods.md.hbs" Start -->

<a name="section-doc-guides-03-methods-md"></a>

Methods
---------

The following methods are provided by the API

+ [.ping(pong)](#method-ping)
+ [.issue(email)](#method-issue)
+ [.check(token)](#method-check)
+ [.update(token, newPassword)](#method-update)
+ [.one(id)](#method-one)
+ [.last(email)](#method-last)

<a name="method-ping"></a>
### .ping(pong)

Test the reachability of the api.

| Param | Type | Description |
| ----- | ---- | ----------- |
| pong  | <code>string</code> | Pong message to return |

<a name="method-issue"></a>
### .issue(email)

Issue recover token to email

| Param | Type | Description |
| ----- | ---- | ----------- |
| email  | <code>string</code> |  |

<a name="method-check"></a>
### .check(token)

Confirm email

| Param | Type | Description |
| ----- | ---- | ----------- |
| token  | <code>string</code> | Recover token |

<a name="method-update"></a>
### .update(token, newPassword)

Update password

| Param | Type | Description |
| ----- | ---- | ----------- |
| token  | <code>string</code> | Recover token |
| newPassword  | <code>string</code> | New password |

<a name="method-one"></a>
### .one(id)

Get an recover

| Param | Type | Description |
| ----- | ---- | ----------- |
| id  | <code>string</code> |  |

<a name="method-last"></a>
### .last(email)

Get last recover for current user

| Param | Type | Description |
| ----- | ---- | ----------- |
| email  | <code>string</code> |  |



<!-- Section from "doc/guides/03.Methods.md.hbs" End -->


<!-- Sections Start -->


<!-- LICENSE Start -->
<a name="license"></a>

License
-------
This software is released under the [MIT License](https://github.com/apeman-api-labo/apeman-api-recover/blob/master/LICENSE).

<!-- LICENSE End -->


<!-- Links Start -->
<a name="links"></a>

Links
------

+ [apeman][apeman_url]

[apeman_url]: https://github.com/apeman-labo/apeman

<!-- Links End -->
